package visnow.template2;

import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;
import pl.edu.icm.visnow.datasets.IrregularField;
import pl.edu.icm.visnow.datasets.RegularField;
import pl.edu.icm.visnow.engine.core.InputEgg;
import pl.edu.icm.visnow.engine.core.OutputEgg;
import pl.edu.icm.visnow.engine.core.ParameterChangeListener;
import pl.edu.icm.visnow.lib.templates.visualization.modules.OutFieldVisualizationModule;
import pl.edu.icm.visnow.lib.types.VNIrregularField;
import pl.edu.icm.visnow.lib.types.VNRegularField;
import pl.edu.icm.visnow.lib.utils.SwingInstancer;

public class ModuleTemplate extends OutFieldVisualizationModule {

    public static InputEgg[] inputEggs = null;
    public static OutputEgg[] outputEggs = null;
    private GUI computeUI;
    private Params params;
    private boolean fromParams = false;
    //private Field inField;

    public ModuleTemplate() {
        parameters = params = new Params();
        
        //add state change listener
        params.addChangeListener(new ChangeListener() {
            @Override
            public void stateChanged(ChangeEvent e) {
                //this is called when params are set Active and execute fireStateChanged()
                //only when explicitly used by programmer
                fromParams = true;
                startAction();
            }
        });
        
        //sometimes more advisable is to add parameter change listener
        params.addParameterChangelistener(new ParameterChangeListener() {
            @Override
            public void parameterChanged(String name) {
                //this is called when params are set ParamsActive and execute fireParameterChanged()
                //every time a parameter value is set                
            }
        });
        
        //do all Swing initializations in proper thread
        SwingInstancer.swingRunAndWait(new Runnable() {
            @Override
            public void run() {
                computeUI = new GUI();
                computeUI.setParams(params);
                ui.addComputeGUI(computeUI);
                setPanel(ui);
            }
        });
    }

    
    @Override
    public void onActive() {
        //onActive() is executed when module starts
        
        if(!fromParams) {
            // here do some processing when module is started externamlly or from network
            // usually this means some new data have arrived
            // e.g.
            // if(getInputFirstValue("inField") != null) {
            //     inField = ((VNField)getInputFirstValue("inField")).getField();  //get data from input port
            //     computeUI.setInField(inField);                                  //set field to GUI to fill controls
            // }
        }
        
        //here do main module processing, creating output data outField based on settings in params and input data
        // e.g.
        // outField = do_something();                                         //do calculations        
        //if(outField instanceof RegularField) {
        //    outRegularField = (RegularField)outField;
        //    outIrregularField = null;
        //    setOutputValue("outRegularField", new VNRegularField(outRegularField));          //set regular output port value
        //    setOutputValue("outIrregularField", null);                                       //set ireeegular output port value
        //} else if(outField instanceof IrregularField) {
        //    outIrregularField = (IrregularField)outField;
        //    outRegularField = null;
        //    setOutputValue("outIrregularField", new VNIrregularField(outIrregularField));    //set ireeegular output port value
        //    setOutputValue("outRegularField", null);                
        //}
        
                
        prepareOutputGeometry();    //create default presentation of outField
        show();                     //and send it to output 
        fromParams = false;
    }

}
